diff --git a/.gitmodules b/.gitmodules
index 2b6786dfa1c3a000b05392980e7b7404bb607b6e..7cbfc1df199b80e2e9d2fdd79a3e62131cad3c64 100644
--- a/.gitmodules
+++ b/.gitmodules
@@ -60,3 +60,6 @@
 [submodule "irdb-sdk"]
 	path = irdb-sdk
 	url = git@git.zephyr-software.com:allnp/irdb-sdk.git
+[submodule "zipr_xeon_plugin"]
+	path = zipr_xeon_plugin
+	url = git@git.zephyr-software.com:allnp/xeon_plugin
diff --git a/SMPStaticAnalyzer b/SMPStaticAnalyzer
index 4f44223a87b941d499cd16da841fd37eb48d4807..46cba78a0e69c1e8d2302930a7fc80a05ec13232 160000
--- a/SMPStaticAnalyzer
+++ b/SMPStaticAnalyzer
@@ -1 +1 @@
-Subproject commit 4f44223a87b941d499cd16da841fd37eb48d4807
+Subproject commit 46cba78a0e69c1e8d2302930a7fc80a05ec13232
diff --git a/build-all.sh b/build-all.sh
index 7beadcb085b837168336df3b5e3ea468eea83e44..023a90d5944a5f0b742de85921671f52e4483f45 100755
--- a/build-all.sh
+++ b/build-all.sh
@@ -29,6 +29,11 @@ mkdir -p $ZEST_RUNTIME/lib64
 mkdir -p $ZEST_RUNTIME/bin
 mkdir -p $ZEST_RUNTIME/sbin
 
+if [ "$(ls -A "$PEDI_HOME" 2> /dev/null)" == "" ]; then
+	echo "pedi submodule is empty. Did you clone using --recursive?";
+	exit 1;
+fi 
+
 if [ ! -f manifest.txt.config -o ! -d "$PS_INSTALL" ]; then
 	mkdir -p "$PS_INSTALL"
 	$PEDI_HOME/pedi --setup -m manifest.txt -l ida -l ida_key -l ps -l zipr -l stars -i $PS_INSTALL
@@ -115,6 +120,11 @@ if [ -d $ZIPR_SCFI_PLUGIN ]; then
 	scons  $SCONSDEBUG || exit 1
 fi
 
+if [ -d $ZIPR_XEON_PLUGIN ]; then
+        cd $ZIPR_XEON_PLUGIN
+        scons  $SCONSDEBUG || exit
+fi
+
 cd $PEASOUP_UMBRELLA_DIR/zipr_large_only_plugin/
 scons $SCONSDEBUG || exit 1
 
diff --git a/clean-all.sh b/clean-all.sh
index 1bc91ea0199fa12aa938b3814490cc7cf52ee29b..673095943cf6a997847f640cb6a4f66df0ce9d7f 100755
--- a/clean-all.sh
+++ b/clean-all.sh
@@ -10,6 +10,11 @@ if [ "$PEASOUP_UMBRELLA_DIR" != "$FULL_BUILD_LOC" ]; then
     exit 1;
 fi
 
+if [ "$(ls -A "$PEDI_HOME" 2> /dev/null)" == "" ]; then
+        echo "pedi submodule is empty. Did you clone using --recursive?";
+        exit 1;
+fi
+
 use_strata=0
 if [[ $use_strata = 1 ]] ; then
 	# stratafier
diff --git a/irdb-sdk b/irdb-sdk
index fc5f9496fde5728597bd38896c3e51be08c6203c..e74ad988db681906932c41957539ceef53565dd1 160000
--- a/irdb-sdk
+++ b/irdb-sdk
@@ -1 +1 @@
-Subproject commit fc5f9496fde5728597bd38896c3e51be08c6203c
+Subproject commit e74ad988db681906932c41957539ceef53565dd1
diff --git a/irdb_transforms b/irdb_transforms
index 82603141950e834693264ef6021305452bd748ce..4f1f24632054a5ac1c4cf4653c57d625930b525d 160000
--- a/irdb_transforms
+++ b/irdb_transforms
@@ -1 +1 @@
-Subproject commit 82603141950e834693264ef6021305452bd748ce
+Subproject commit 4f1f24632054a5ac1c4cf4653c57d625930b525d
diff --git a/security_transforms b/security_transforms
index c9e7222c45a17e84319b68df829e4616882adbf4..fad0d8e056415fe834f60ae5db84f8ef52644a30 160000
--- a/security_transforms
+++ b/security_transforms
@@ -1 +1 @@
-Subproject commit c9e7222c45a17e84319b68df829e4616882adbf4
+Subproject commit fad0d8e056415fe834f60ae5db84f8ef52644a30
diff --git a/set_env_vars b/set_env_vars
index b2b7772e49cb2159ff7dfdf7c1d83ffcc3a2c268..8d6892bf5264e4dc933abff8801569e5a70acc11 100644
--- a/set_env_vars
+++ b/set_env_vars
@@ -17,6 +17,7 @@ export ZIPR_INSTALL=$PEASOUP_UMBRELLA_DIR/zipr_install
 export ZIPR_CALLBACKS=$PEASOUP_UMBRELLA_DIR/zipr_callbacks
 export ZIPR_SDK=$PEASOUP_UMBRELLA_DIR/zipr_sdk
 export ZIPR_SCFI_PLUGIN=$PEASOUP_UMBRELLA_DIR/zipr_scfi_plugin
+export ZIPR_XEON_PLUGIN=$PEASOUP_UMBRELLA_DIR/zipr_xeon_plugin
 export SECURITY_TRANSFORMS_HOME=$PEASOUP_UMBRELLA_DIR/security_transforms
 export IRDB_SDK=$PEASOUP_UMBRELLA_DIR/irdb-sdk
 export IRDB_TRANSFORMS=$PEASOUP_UMBRELLA_DIR/irdb_transforms
diff --git a/zipr_install b/zipr_install
index 97ab5ded5890c3a86e7cc1124d8f68c1557e8d53..3c03d1d879d783a880b7989c38c5d83fe92e1c84 160000
--- a/zipr_install
+++ b/zipr_install
@@ -1 +1 @@
-Subproject commit 97ab5ded5890c3a86e7cc1124d8f68c1557e8d53
+Subproject commit 3c03d1d879d783a880b7989c38c5d83fe92e1c84
diff --git a/zipr_xeon_plugin b/zipr_xeon_plugin
new file mode 160000
index 0000000000000000000000000000000000000000..e176a7818d531362e700cba0719f6ad55f1a9ffc
--- /dev/null
+++ b/zipr_xeon_plugin
@@ -0,0 +1 @@
+Subproject commit e176a7818d531362e700cba0719f6ad55f1a9ffc